# Add project specific ProGuard rules here.
# You can control the set of applied configuration files using the
# proguardFiles setting in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Keep models intact
-keep class com.pixelmintdrop.model.** { *; }

# Keep game classes intact to prevent issues
-keep class com.pixelmintdrop.game.** { *; }

# Preserve critical classes that might be used through reflection
-keep class com.pixelmintdrop.audio.GameMusic { *; }
-keep class com.pixelmintdrop.ui.** { *; }

# Keep all public methods in the MainActivity
-keepclassmembers class com.pixelmintdrop.MainActivity {
    public *;
}

# Keep serializable and parcelable classes for proper game state saving
-keepnames class * implements java.io.Serializable
-keepclassmembers class * implements java.io.Serializable {
    static final long serialVersionUID;
    private static final java.io.ObjectStreamField[] serialPersistentFields;
    !static !transient <fields>;
    private void writeObject(java.io.ObjectOutputStream);
    private void readObject(java.io.ObjectInputStream);
    java.lang.Object writeReplace();
    java.lang.Object readResolve();
}

# Preserve line number information for debugging stack traces
-keepattributes SourceFile,LineNumberTable

# Keep Gson usage intact
-keep class com.google.gson.** { *; }
-keep class * implements com.google.gson.TypeAdapterFactory
-keep class * implements com.google.gson.JsonSerializer
-keep class * implements com.google.gson.JsonDeserializer

# Uncomment this to preserve the line number information for
# debugging stack traces.
#-keepattributes SourceFile,LineNumberTable

# If you keep the line number information, uncomment this to
# hide the original source file name.
#-renamesourcefileattribute SourceFile 